# This Perl script will apply the project.xsl to every
# timeline.xml found in the current directory or recursively to
# any directory below that. Then it will consolidate all the timeline.xml's
# into a single XML file called 'bluesheet.xml'. It then processes 
# 'bluesheet.xml' with three different xsl sheets, "bluesheet.xsl", "timelines.xsl" and
# "pipeline.xsl".

use Cwd;
use File::Find;

open(BLUESHEET, "> bluesheet.xml") or die "Couldn't open bluesheet.xml for writing: $!\n";
print BLUESHEET "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
print BLUESHEET "<program>\n";


sub process_file {
    if (/timeline.xml/i) {
	`austin -png timeline.xml`;
	$dir = cwd;
	`testxslt -IN \"file:///$dir\\timeline.xml\" -OUT timeline.html -XSL file:///sw_dev\\austin\\xslt\\project.xsl`;
	print "Processing $File::Find::name\n";
	open(TIMELINE, "< $_") or die "Couldn't open $File::Find::name for reading: $!\n";
	while (<TIMELINE>) {
	    if ($_ !~ m/^<[\?\!]/) {
		if ($_ =~ m/^<project/) {
		    $fullpath = $File::Find::name;
		    $fullpath =~ s/ /%20/g;
		    $fullpath =~ tr/A-Z/a-z/;
		    s/>$/ fullpath="$fullpath">/;
		}
		print BLUESHEET $_;
 	    }
        }
	close(TIMELINE);
    }
}


@DIRLIST = qw(.);
find(\&process_file, @DIRLIST);

print BLUESHEET "</program>\n";

close(BLUESHEET);

use Cwd;
$dir = cwd;
system "testxslt -IN file:///$dir\\bluesheet.xml -OUT bluesheet.html -XSL file:///sw_dev\\austin\\xslt\\bluesheet.xsl";
system "testxslt -in file:///$dir\\bluesheet.xml -out timelines.html -xsl file:///sw_dev\\austin\\xslt\\timelines.xsl";
system "testxslt -in file:///$dir\\bluesheet.xml -out pipeline.html -xsl file:///sw_dev\\austin\\xslt\\pipeline.xsl";
system "testxslt -in file:///$dir\\bluesheet.xml -out ideas.html -xsl file:///sw_dev\\austin\\xslt\\ideas.xsl";













